/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.gen4gen.service;

import java.io.Reader;

import net.sf.parser4j.gen4gen.entity.InputGrammar4GenReader;
import net.sf.parser4j.generator.entity.parserdata.ParserDataForGeneratorInput;
import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.entity.data.ParserData;
import net.sf.parser4j.parser.service.IParserListener;
import net.sf.parser4j.parser.service.Parser;

import org.apache.log4j.Logger;

/**
 * final test: parse definitive generator input grammar text file using parser
 * data generated using this file
 * 
 * @author luc peuvrier
 * 
 */
public final class MainParseDefinitiveByDefinitiveTest {

	private static final Logger _log = Logger
			.getLogger(MainParseDefinitiveByDefinitiveTest.class);

	private static final InputGrammar4GenReader inputGrammar4GenReader =
	/**/InputGrammar4GenReader.getInstance();

	private final static ParserDataForGeneratorInput parserDataForGeneratorInput =
	/**/ParserDataForGeneratorInput.getInstance();

	public static void main(final String[] args) {
		try {
			_log
					.info(
					/**/"parse definitive grammar text file using definitive parser data");
			final IParserListener listener = null;// FIXME
			final ParserData definitiveTxtParserData = parserDataForGeneratorInput
					.read();
			final Parser parser = new Parser(definitiveTxtParserData, listener);
			final Reader reader = inputGrammar4GenReader
					.createDefinitiveGrammarInput4GenReader();
			final ParseResult parseResult = parser
					.parse(reader, false/* syntaxAcceptAmbiguity */, false/* lexAcceptAmbiguity */);
			// final IParseNode rootParseNode =
			// parseResult.getResultParseNode();
			if (parseResult.isInError()) {
				_log.error(parseResult);
			} else {
				_log.info(parseResult);
			}
		} catch (Exception exception) {
			_log.error("error while parsing definitive by definitive",
					exception);
		}
	}

	private MainParseDefinitiveByDefinitiveTest() {
		super();
	}
}
