/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generateandparsetest.test;

import java.io.StringReader;

import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.entity.parsenode.IParseNode;
import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.Parser;
import net.sf.parser4j.parser.service.ParserException;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class RangeGrammarTest extends AbstractGrammarTest {

	public void testRangeGrammar() throws ParserException,
			HasAmbiguityParserException {// NOPMD
		final Parser parser = createParser("range.xml");
		/*
		 * parsing of "b"
		 */
		StringReader reader = new StringReader("b");

		ParseResult result = parser.parse(reader, false, false);
		IParseNode parseNode = result.getResultParseNode();
		assertFalse("must have one result\n" + result, result.isInError());
		assertFalse("must not have alternative for ambiguity", parser
				.hasAlternativeForAmbiguity());

		String expected = "terminal 'b'\n";
		assertEquals("not same output", expected, parseNode.toString());

		/*
		 * parsing of "c"
		 */
		reader = new StringReader("c");

		result = parser.parse(reader, false, false);
		parseNode = result.getResultParseNode();
		assertFalse("must have one result\n" + result, result.isInError());
		expected = "terminal 'c'\n";
		assertEquals("not same output", expected, parseNode.toString());
	}

	public void newLine(final int line) {
		//
	}
}
